// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: PTMatch.proto

package com.fss.fo.mserver.exchange;

public final class PTMatchProtos {
  private PTMatchProtos() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public interface PTMatchOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // optional string Id = 1;
    /**
     * <code>optional string Id = 1;</code>
     */
    boolean hasId();
    /**
     * <code>optional string Id = 1;</code>
     */
    java.lang.String getId();
    /**
     * <code>optional string Id = 1;</code>
     */
    com.google.protobuf.ByteString
        getIdBytes();

    // optional string Symbol = 2;
    /**
     * <code>optional string Symbol = 2;</code>
     */
    boolean hasSymbol();
    /**
     * <code>optional string Symbol = 2;</code>
     */
    java.lang.String getSymbol();
    /**
     * <code>optional string Symbol = 2;</code>
     */
    com.google.protobuf.ByteString
        getSymbolBytes();

    // optional string ConfirmNo = 3;
    /**
     * <code>optional string ConfirmNo = 3;</code>
     */
    boolean hasConfirmNo();
    /**
     * <code>optional string ConfirmNo = 3;</code>
     */
    java.lang.String getConfirmNo();
    /**
     * <code>optional string ConfirmNo = 3;</code>
     */
    com.google.protobuf.ByteString
        getConfirmNoBytes();

    // optional int64 MatchVol = 4;
    /**
     * <code>optional int64 MatchVol = 4;</code>
     */
    boolean hasMatchVol();
    /**
     * <code>optional int64 MatchVol = 4;</code>
     */
    long getMatchVol();

    // optional string Price = 5;
    /**
     * <code>optional string Price = 5;</code>
     */
    boolean hasPrice();
    /**
     * <code>optional string Price = 5;</code>
     */
    java.lang.String getPrice();
    /**
     * <code>optional string Price = 5;</code>
     */
    com.google.protobuf.ByteString
        getPriceBytes();

    // optional string MarketId = 6;
    /**
     * <code>optional string MarketId = 6;</code>
     */
    boolean hasMarketId();
    /**
     * <code>optional string MarketId = 6;</code>
     */
    java.lang.String getMarketId();
    /**
     * <code>optional string MarketId = 6;</code>
     */
    com.google.protobuf.ByteString
        getMarketIdBytes();

    // optional bool IsActive = 7;
    /**
     * <code>optional bool IsActive = 7;</code>
     */
    boolean hasIsActive();
    /**
     * <code>optional bool IsActive = 7;</code>
     */
    boolean getIsActive();

    // optional string tradingdate = 8;
    /**
     * <code>optional string tradingdate = 8;</code>
     */
    boolean hasTradingdate();
    /**
     * <code>optional string tradingdate = 8;</code>
     */
    java.lang.String getTradingdate();
    /**
     * <code>optional string tradingdate = 8;</code>
     */
    com.google.protobuf.ByteString
        getTradingdateBytes();

    // optional string Time = 9;
    /**
     * <code>optional string Time = 9;</code>
     */
    boolean hasTime();
    /**
     * <code>optional string Time = 9;</code>
     */
    java.lang.String getTime();
    /**
     * <code>optional string Time = 9;</code>
     */
    com.google.protobuf.ByteString
        getTimeBytes();

    // optional int64 LastSeq = 10;
    /**
     * <code>optional int64 LastSeq = 10;</code>
     */
    boolean hasLastSeq();
    /**
     * <code>optional int64 LastSeq = 10;</code>
     */
    long getLastSeq();

    // optional string PColor = 11;
    /**
     * <code>optional string PColor = 11;</code>
     */
    boolean hasPColor();
    /**
     * <code>optional string PColor = 11;</code>
     */
    java.lang.String getPColor();
    /**
     * <code>optional string PColor = 11;</code>
     */
    com.google.protobuf.ByteString
        getPColorBytes();
  }
  /**
   * Protobuf type {@code com.fss.fo.mserver.exchange.PTMatch}
   */
  public static final class PTMatch extends
      com.google.protobuf.GeneratedMessage
      implements PTMatchOrBuilder {
    // Use PTMatch.newBuilder() to construct.
    private PTMatch(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private PTMatch(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final PTMatch defaultInstance;
    public static PTMatch getDefaultInstance() {
      return defaultInstance;
    }

    public PTMatch getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private PTMatch(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              bitField0_ |= 0x00000001;
              id_ = input.readBytes();
              break;
            }
            case 18: {
              bitField0_ |= 0x00000002;
              symbol_ = input.readBytes();
              break;
            }
            case 26: {
              bitField0_ |= 0x00000004;
              confirmNo_ = input.readBytes();
              break;
            }
            case 32: {
              bitField0_ |= 0x00000008;
              matchVol_ = input.readInt64();
              break;
            }
            case 42: {
              bitField0_ |= 0x00000010;
              price_ = input.readBytes();
              break;
            }
            case 50: {
              bitField0_ |= 0x00000020;
              marketId_ = input.readBytes();
              break;
            }
            case 56: {
              bitField0_ |= 0x00000040;
              isActive_ = input.readBool();
              break;
            }
            case 66: {
              bitField0_ |= 0x00000080;
              tradingdate_ = input.readBytes();
              break;
            }
            case 74: {
              bitField0_ |= 0x00000100;
              time_ = input.readBytes();
              break;
            }
            case 80: {
              bitField0_ |= 0x00000200;
              lastSeq_ = input.readInt64();
              break;
            }
            case 90: {
              bitField0_ |= 0x00000400;
              pColor_ = input.readBytes();
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.fss.fo.mserver.exchange.PTMatchProtos.internal_static_com_fss_fo_mserver_exchange_PTMatch_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.fss.fo.mserver.exchange.PTMatchProtos.internal_static_com_fss_fo_mserver_exchange_PTMatch_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch.class, com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch.Builder.class);
    }

    public static com.google.protobuf.Parser<PTMatch> PARSER =
        new com.google.protobuf.AbstractParser<PTMatch>() {
      public PTMatch parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new PTMatch(input, extensionRegistry);
      }
    };

    @java.lang.Override
    public com.google.protobuf.Parser<PTMatch> getParserForType() {
      return PARSER;
    }

    private int bitField0_;
    // optional string Id = 1;
    public static final int ID_FIELD_NUMBER = 1;
    private java.lang.Object id_;
    /**
     * <code>optional string Id = 1;</code>
     */
    public boolean hasId() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>optional string Id = 1;</code>
     */
    public java.lang.String getId() {
      java.lang.Object ref = id_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          id_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string Id = 1;</code>
     */
    public com.google.protobuf.ByteString
        getIdBytes() {
      java.lang.Object ref = id_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        id_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string Symbol = 2;
    public static final int SYMBOL_FIELD_NUMBER = 2;
    private java.lang.Object symbol_;
    /**
     * <code>optional string Symbol = 2;</code>
     */
    public boolean hasSymbol() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    /**
     * <code>optional string Symbol = 2;</code>
     */
    public java.lang.String getSymbol() {
      java.lang.Object ref = symbol_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          symbol_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string Symbol = 2;</code>
     */
    public com.google.protobuf.ByteString
        getSymbolBytes() {
      java.lang.Object ref = symbol_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        symbol_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string ConfirmNo = 3;
    public static final int CONFIRMNO_FIELD_NUMBER = 3;
    private java.lang.Object confirmNo_;
    /**
     * <code>optional string ConfirmNo = 3;</code>
     */
    public boolean hasConfirmNo() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    /**
     * <code>optional string ConfirmNo = 3;</code>
     */
    public java.lang.String getConfirmNo() {
      java.lang.Object ref = confirmNo_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          confirmNo_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string ConfirmNo = 3;</code>
     */
    public com.google.protobuf.ByteString
        getConfirmNoBytes() {
      java.lang.Object ref = confirmNo_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        confirmNo_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional int64 MatchVol = 4;
    public static final int MATCHVOL_FIELD_NUMBER = 4;
    private long matchVol_;
    /**
     * <code>optional int64 MatchVol = 4;</code>
     */
    public boolean hasMatchVol() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    /**
     * <code>optional int64 MatchVol = 4;</code>
     */
    public long getMatchVol() {
      return matchVol_;
    }

    // optional string Price = 5;
    public static final int PRICE_FIELD_NUMBER = 5;
    private java.lang.Object price_;
    /**
     * <code>optional string Price = 5;</code>
     */
    public boolean hasPrice() {
      return ((bitField0_ & 0x00000010) == 0x00000010);
    }
    /**
     * <code>optional string Price = 5;</code>
     */
    public java.lang.String getPrice() {
      java.lang.Object ref = price_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          price_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string Price = 5;</code>
     */
    public com.google.protobuf.ByteString
        getPriceBytes() {
      java.lang.Object ref = price_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        price_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string MarketId = 6;
    public static final int MARKETID_FIELD_NUMBER = 6;
    private java.lang.Object marketId_;
    /**
     * <code>optional string MarketId = 6;</code>
     */
    public boolean hasMarketId() {
      return ((bitField0_ & 0x00000020) == 0x00000020);
    }
    /**
     * <code>optional string MarketId = 6;</code>
     */
    public java.lang.String getMarketId() {
      java.lang.Object ref = marketId_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          marketId_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string MarketId = 6;</code>
     */
    public com.google.protobuf.ByteString
        getMarketIdBytes() {
      java.lang.Object ref = marketId_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        marketId_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional bool IsActive = 7;
    public static final int ISACTIVE_FIELD_NUMBER = 7;
    private boolean isActive_;
    /**
     * <code>optional bool IsActive = 7;</code>
     */
    public boolean hasIsActive() {
      return ((bitField0_ & 0x00000040) == 0x00000040);
    }
    /**
     * <code>optional bool IsActive = 7;</code>
     */
    public boolean getIsActive() {
      return isActive_;
    }

    // optional string tradingdate = 8;
    public static final int TRADINGDATE_FIELD_NUMBER = 8;
    private java.lang.Object tradingdate_;
    /**
     * <code>optional string tradingdate = 8;</code>
     */
    public boolean hasTradingdate() {
      return ((bitField0_ & 0x00000080) == 0x00000080);
    }
    /**
     * <code>optional string tradingdate = 8;</code>
     */
    public java.lang.String getTradingdate() {
      java.lang.Object ref = tradingdate_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          tradingdate_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string tradingdate = 8;</code>
     */
    public com.google.protobuf.ByteString
        getTradingdateBytes() {
      java.lang.Object ref = tradingdate_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        tradingdate_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string Time = 9;
    public static final int TIME_FIELD_NUMBER = 9;
    private java.lang.Object time_;
    /**
     * <code>optional string Time = 9;</code>
     */
    public boolean hasTime() {
      return ((bitField0_ & 0x00000100) == 0x00000100);
    }
    /**
     * <code>optional string Time = 9;</code>
     */
    public java.lang.String getTime() {
      java.lang.Object ref = time_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          time_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string Time = 9;</code>
     */
    public com.google.protobuf.ByteString
        getTimeBytes() {
      java.lang.Object ref = time_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        time_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional int64 LastSeq = 10;
    public static final int LASTSEQ_FIELD_NUMBER = 10;
    private long lastSeq_;
    /**
     * <code>optional int64 LastSeq = 10;</code>
     */
    public boolean hasLastSeq() {
      return ((bitField0_ & 0x00000200) == 0x00000200);
    }
    /**
     * <code>optional int64 LastSeq = 10;</code>
     */
    public long getLastSeq() {
      return lastSeq_;
    }

    // optional string PColor = 11;
    public static final int PCOLOR_FIELD_NUMBER = 11;
    private java.lang.Object pColor_;
    /**
     * <code>optional string PColor = 11;</code>
     */
    public boolean hasPColor() {
      return ((bitField0_ & 0x00000400) == 0x00000400);
    }
    /**
     * <code>optional string PColor = 11;</code>
     */
    public java.lang.String getPColor() {
      java.lang.Object ref = pColor_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          pColor_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string PColor = 11;</code>
     */
    public com.google.protobuf.ByteString
        getPColorBytes() {
      java.lang.Object ref = pColor_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        pColor_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    private void initFields() {
      id_ = "";
      symbol_ = "";
      confirmNo_ = "";
      matchVol_ = 0L;
      price_ = "";
      marketId_ = "";
      isActive_ = false;
      tradingdate_ = "";
      time_ = "";
      lastSeq_ = 0L;
      pColor_ = "";
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeBytes(1, getIdBytes());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeBytes(2, getSymbolBytes());
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeBytes(3, getConfirmNoBytes());
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeInt64(4, matchVol_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        output.writeBytes(5, getPriceBytes());
      }
      if (((bitField0_ & 0x00000020) == 0x00000020)) {
        output.writeBytes(6, getMarketIdBytes());
      }
      if (((bitField0_ & 0x00000040) == 0x00000040)) {
        output.writeBool(7, isActive_);
      }
      if (((bitField0_ & 0x00000080) == 0x00000080)) {
        output.writeBytes(8, getTradingdateBytes());
      }
      if (((bitField0_ & 0x00000100) == 0x00000100)) {
        output.writeBytes(9, getTimeBytes());
      }
      if (((bitField0_ & 0x00000200) == 0x00000200)) {
        output.writeInt64(10, lastSeq_);
      }
      if (((bitField0_ & 0x00000400) == 0x00000400)) {
        output.writeBytes(11, getPColorBytes());
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(1, getIdBytes());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(2, getSymbolBytes());
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(3, getConfirmNoBytes());
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(4, matchVol_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(5, getPriceBytes());
      }
      if (((bitField0_ & 0x00000020) == 0x00000020)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(6, getMarketIdBytes());
      }
      if (((bitField0_ & 0x00000040) == 0x00000040)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBoolSize(7, isActive_);
      }
      if (((bitField0_ & 0x00000080) == 0x00000080)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(8, getTradingdateBytes());
      }
      if (((bitField0_ & 0x00000100) == 0x00000100)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(9, getTimeBytes());
      }
      if (((bitField0_ & 0x00000200) == 0x00000200)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(10, lastSeq_);
      }
      if (((bitField0_ & 0x00000400) == 0x00000400)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(11, getPColorBytes());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    public static com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code com.fss.fo.mserver.exchange.PTMatch}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements com.fss.fo.mserver.exchange.PTMatchProtos.PTMatchOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.fss.fo.mserver.exchange.PTMatchProtos.internal_static_com_fss_fo_mserver_exchange_PTMatch_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.fss.fo.mserver.exchange.PTMatchProtos.internal_static_com_fss_fo_mserver_exchange_PTMatch_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch.class, com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch.Builder.class);
      }

      // Construct using com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        id_ = "";
        bitField0_ = (bitField0_ & ~0x00000001);
        symbol_ = "";
        bitField0_ = (bitField0_ & ~0x00000002);
        confirmNo_ = "";
        bitField0_ = (bitField0_ & ~0x00000004);
        matchVol_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000008);
        price_ = "";
        bitField0_ = (bitField0_ & ~0x00000010);
        marketId_ = "";
        bitField0_ = (bitField0_ & ~0x00000020);
        isActive_ = false;
        bitField0_ = (bitField0_ & ~0x00000040);
        tradingdate_ = "";
        bitField0_ = (bitField0_ & ~0x00000080);
        time_ = "";
        bitField0_ = (bitField0_ & ~0x00000100);
        lastSeq_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000200);
        pColor_ = "";
        bitField0_ = (bitField0_ & ~0x00000400);
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.fss.fo.mserver.exchange.PTMatchProtos.internal_static_com_fss_fo_mserver_exchange_PTMatch_descriptor;
      }

      public com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch getDefaultInstanceForType() {
        return com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch.getDefaultInstance();
      }

      public com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch build() {
        com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch buildPartial() {
        com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch result = new com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.id_ = id_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.symbol_ = symbol_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.confirmNo_ = confirmNo_;
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.matchVol_ = matchVol_;
        if (((from_bitField0_ & 0x00000010) == 0x00000010)) {
          to_bitField0_ |= 0x00000010;
        }
        result.price_ = price_;
        if (((from_bitField0_ & 0x00000020) == 0x00000020)) {
          to_bitField0_ |= 0x00000020;
        }
        result.marketId_ = marketId_;
        if (((from_bitField0_ & 0x00000040) == 0x00000040)) {
          to_bitField0_ |= 0x00000040;
        }
        result.isActive_ = isActive_;
        if (((from_bitField0_ & 0x00000080) == 0x00000080)) {
          to_bitField0_ |= 0x00000080;
        }
        result.tradingdate_ = tradingdate_;
        if (((from_bitField0_ & 0x00000100) == 0x00000100)) {
          to_bitField0_ |= 0x00000100;
        }
        result.time_ = time_;
        if (((from_bitField0_ & 0x00000200) == 0x00000200)) {
          to_bitField0_ |= 0x00000200;
        }
        result.lastSeq_ = lastSeq_;
        if (((from_bitField0_ & 0x00000400) == 0x00000400)) {
          to_bitField0_ |= 0x00000400;
        }
        result.pColor_ = pColor_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch) {
          return mergeFrom((com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch other) {
        if (other == com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch.getDefaultInstance()) return this;
        if (other.hasId()) {
          bitField0_ |= 0x00000001;
          id_ = other.id_;
          onChanged();
        }
        if (other.hasSymbol()) {
          bitField0_ |= 0x00000002;
          symbol_ = other.symbol_;
          onChanged();
        }
        if (other.hasConfirmNo()) {
          bitField0_ |= 0x00000004;
          confirmNo_ = other.confirmNo_;
          onChanged();
        }
        if (other.hasMatchVol()) {
          setMatchVol(other.getMatchVol());
        }
        if (other.hasPrice()) {
          bitField0_ |= 0x00000010;
          price_ = other.price_;
          onChanged();
        }
        if (other.hasMarketId()) {
          bitField0_ |= 0x00000020;
          marketId_ = other.marketId_;
          onChanged();
        }
        if (other.hasIsActive()) {
          setIsActive(other.getIsActive());
        }
        if (other.hasTradingdate()) {
          bitField0_ |= 0x00000080;
          tradingdate_ = other.tradingdate_;
          onChanged();
        }
        if (other.hasTime()) {
          bitField0_ |= 0x00000100;
          time_ = other.time_;
          onChanged();
        }
        if (other.hasLastSeq()) {
          setLastSeq(other.getLastSeq());
        }
        if (other.hasPColor()) {
          bitField0_ |= 0x00000400;
          pColor_ = other.pColor_;
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (com.fss.fo.mserver.exchange.PTMatchProtos.PTMatch) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // optional string Id = 1;
      private java.lang.Object id_ = "";
      /**
       * <code>optional string Id = 1;</code>
       */
      public boolean hasId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public java.lang.String getId() {
        java.lang.Object ref = id_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          id_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public com.google.protobuf.ByteString
          getIdBytes() {
        java.lang.Object ref = id_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          id_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public Builder setId(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        id_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public Builder clearId() {
        bitField0_ = (bitField0_ & ~0x00000001);
        id_ = getDefaultInstance().getId();
        onChanged();
        return this;
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public Builder setIdBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        id_ = value;
        onChanged();
        return this;
      }

      // optional string Symbol = 2;
      private java.lang.Object symbol_ = "";
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public boolean hasSymbol() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public java.lang.String getSymbol() {
        java.lang.Object ref = symbol_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          symbol_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public com.google.protobuf.ByteString
          getSymbolBytes() {
        java.lang.Object ref = symbol_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          symbol_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public Builder setSymbol(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        symbol_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public Builder clearSymbol() {
        bitField0_ = (bitField0_ & ~0x00000002);
        symbol_ = getDefaultInstance().getSymbol();
        onChanged();
        return this;
      }
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public Builder setSymbolBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        symbol_ = value;
        onChanged();
        return this;
      }

      // optional string ConfirmNo = 3;
      private java.lang.Object confirmNo_ = "";
      /**
       * <code>optional string ConfirmNo = 3;</code>
       */
      public boolean hasConfirmNo() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      /**
       * <code>optional string ConfirmNo = 3;</code>
       */
      public java.lang.String getConfirmNo() {
        java.lang.Object ref = confirmNo_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          confirmNo_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string ConfirmNo = 3;</code>
       */
      public com.google.protobuf.ByteString
          getConfirmNoBytes() {
        java.lang.Object ref = confirmNo_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          confirmNo_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string ConfirmNo = 3;</code>
       */
      public Builder setConfirmNo(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        confirmNo_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string ConfirmNo = 3;</code>
       */
      public Builder clearConfirmNo() {
        bitField0_ = (bitField0_ & ~0x00000004);
        confirmNo_ = getDefaultInstance().getConfirmNo();
        onChanged();
        return this;
      }
      /**
       * <code>optional string ConfirmNo = 3;</code>
       */
      public Builder setConfirmNoBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        confirmNo_ = value;
        onChanged();
        return this;
      }

      // optional int64 MatchVol = 4;
      private long matchVol_ ;
      /**
       * <code>optional int64 MatchVol = 4;</code>
       */
      public boolean hasMatchVol() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      /**
       * <code>optional int64 MatchVol = 4;</code>
       */
      public long getMatchVol() {
        return matchVol_;
      }
      /**
       * <code>optional int64 MatchVol = 4;</code>
       */
      public Builder setMatchVol(long value) {
        bitField0_ |= 0x00000008;
        matchVol_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional int64 MatchVol = 4;</code>
       */
      public Builder clearMatchVol() {
        bitField0_ = (bitField0_ & ~0x00000008);
        matchVol_ = 0L;
        onChanged();
        return this;
      }

      // optional string Price = 5;
      private java.lang.Object price_ = "";
      /**
       * <code>optional string Price = 5;</code>
       */
      public boolean hasPrice() {
        return ((bitField0_ & 0x00000010) == 0x00000010);
      }
      /**
       * <code>optional string Price = 5;</code>
       */
      public java.lang.String getPrice() {
        java.lang.Object ref = price_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          price_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string Price = 5;</code>
       */
      public com.google.protobuf.ByteString
          getPriceBytes() {
        java.lang.Object ref = price_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          price_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string Price = 5;</code>
       */
      public Builder setPrice(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000010;
        price_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string Price = 5;</code>
       */
      public Builder clearPrice() {
        bitField0_ = (bitField0_ & ~0x00000010);
        price_ = getDefaultInstance().getPrice();
        onChanged();
        return this;
      }
      /**
       * <code>optional string Price = 5;</code>
       */
      public Builder setPriceBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000010;
        price_ = value;
        onChanged();
        return this;
      }

      // optional string MarketId = 6;
      private java.lang.Object marketId_ = "";
      /**
       * <code>optional string MarketId = 6;</code>
       */
      public boolean hasMarketId() {
        return ((bitField0_ & 0x00000020) == 0x00000020);
      }
      /**
       * <code>optional string MarketId = 6;</code>
       */
      public java.lang.String getMarketId() {
        java.lang.Object ref = marketId_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          marketId_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string MarketId = 6;</code>
       */
      public com.google.protobuf.ByteString
          getMarketIdBytes() {
        java.lang.Object ref = marketId_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          marketId_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string MarketId = 6;</code>
       */
      public Builder setMarketId(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000020;
        marketId_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string MarketId = 6;</code>
       */
      public Builder clearMarketId() {
        bitField0_ = (bitField0_ & ~0x00000020);
        marketId_ = getDefaultInstance().getMarketId();
        onChanged();
        return this;
      }
      /**
       * <code>optional string MarketId = 6;</code>
       */
      public Builder setMarketIdBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000020;
        marketId_ = value;
        onChanged();
        return this;
      }

      // optional bool IsActive = 7;
      private boolean isActive_ ;
      /**
       * <code>optional bool IsActive = 7;</code>
       */
      public boolean hasIsActive() {
        return ((bitField0_ & 0x00000040) == 0x00000040);
      }
      /**
       * <code>optional bool IsActive = 7;</code>
       */
      public boolean getIsActive() {
        return isActive_;
      }
      /**
       * <code>optional bool IsActive = 7;</code>
       */
      public Builder setIsActive(boolean value) {
        bitField0_ |= 0x00000040;
        isActive_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional bool IsActive = 7;</code>
       */
      public Builder clearIsActive() {
        bitField0_ = (bitField0_ & ~0x00000040);
        isActive_ = false;
        onChanged();
        return this;
      }

      // optional string tradingdate = 8;
      private java.lang.Object tradingdate_ = "";
      /**
       * <code>optional string tradingdate = 8;</code>
       */
      public boolean hasTradingdate() {
        return ((bitField0_ & 0x00000080) == 0x00000080);
      }
      /**
       * <code>optional string tradingdate = 8;</code>
       */
      public java.lang.String getTradingdate() {
        java.lang.Object ref = tradingdate_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          tradingdate_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string tradingdate = 8;</code>
       */
      public com.google.protobuf.ByteString
          getTradingdateBytes() {
        java.lang.Object ref = tradingdate_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          tradingdate_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string tradingdate = 8;</code>
       */
      public Builder setTradingdate(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000080;
        tradingdate_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string tradingdate = 8;</code>
       */
      public Builder clearTradingdate() {
        bitField0_ = (bitField0_ & ~0x00000080);
        tradingdate_ = getDefaultInstance().getTradingdate();
        onChanged();
        return this;
      }
      /**
       * <code>optional string tradingdate = 8;</code>
       */
      public Builder setTradingdateBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000080;
        tradingdate_ = value;
        onChanged();
        return this;
      }

      // optional string Time = 9;
      private java.lang.Object time_ = "";
      /**
       * <code>optional string Time = 9;</code>
       */
      public boolean hasTime() {
        return ((bitField0_ & 0x00000100) == 0x00000100);
      }
      /**
       * <code>optional string Time = 9;</code>
       */
      public java.lang.String getTime() {
        java.lang.Object ref = time_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          time_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string Time = 9;</code>
       */
      public com.google.protobuf.ByteString
          getTimeBytes() {
        java.lang.Object ref = time_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          time_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string Time = 9;</code>
       */
      public Builder setTime(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000100;
        time_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string Time = 9;</code>
       */
      public Builder clearTime() {
        bitField0_ = (bitField0_ & ~0x00000100);
        time_ = getDefaultInstance().getTime();
        onChanged();
        return this;
      }
      /**
       * <code>optional string Time = 9;</code>
       */
      public Builder setTimeBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000100;
        time_ = value;
        onChanged();
        return this;
      }

      // optional int64 LastSeq = 10;
      private long lastSeq_ ;
      /**
       * <code>optional int64 LastSeq = 10;</code>
       */
      public boolean hasLastSeq() {
        return ((bitField0_ & 0x00000200) == 0x00000200);
      }
      /**
       * <code>optional int64 LastSeq = 10;</code>
       */
      public long getLastSeq() {
        return lastSeq_;
      }
      /**
       * <code>optional int64 LastSeq = 10;</code>
       */
      public Builder setLastSeq(long value) {
        bitField0_ |= 0x00000200;
        lastSeq_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional int64 LastSeq = 10;</code>
       */
      public Builder clearLastSeq() {
        bitField0_ = (bitField0_ & ~0x00000200);
        lastSeq_ = 0L;
        onChanged();
        return this;
      }

      // optional string PColor = 11;
      private java.lang.Object pColor_ = "";
      /**
       * <code>optional string PColor = 11;</code>
       */
      public boolean hasPColor() {
        return ((bitField0_ & 0x00000400) == 0x00000400);
      }
      /**
       * <code>optional string PColor = 11;</code>
       */
      public java.lang.String getPColor() {
        java.lang.Object ref = pColor_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          pColor_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string PColor = 11;</code>
       */
      public com.google.protobuf.ByteString
          getPColorBytes() {
        java.lang.Object ref = pColor_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          pColor_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string PColor = 11;</code>
       */
      public Builder setPColor(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000400;
        pColor_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string PColor = 11;</code>
       */
      public Builder clearPColor() {
        bitField0_ = (bitField0_ & ~0x00000400);
        pColor_ = getDefaultInstance().getPColor();
        onChanged();
        return this;
      }
      /**
       * <code>optional string PColor = 11;</code>
       */
      public Builder setPColorBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000400;
        pColor_ = value;
        onChanged();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:com.fss.fo.mserver.exchange.PTMatch)
    }

    static {
      defaultInstance = new PTMatch(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:com.fss.fo.mserver.exchange.PTMatch)
  }

  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_com_fss_fo_mserver_exchange_PTMatch_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_com_fss_fo_mserver_exchange_PTMatch_fieldAccessorTable;

  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\rPTMatch.proto\022\033com.fss.fo.mserver.exch" +
      "ange\"\301\001\n\007PTMatch\022\n\n\002Id\030\001 \001(\t\022\016\n\006Symbol\030\002" +
      " \001(\t\022\021\n\tConfirmNo\030\003 \001(\t\022\020\n\010MatchVol\030\004 \001(" +
      "\003\022\r\n\005Price\030\005 \001(\t\022\020\n\010MarketId\030\006 \001(\t\022\020\n\010Is" +
      "Active\030\007 \001(\010\022\023\n\013tradingdate\030\010 \001(\t\022\014\n\004Tim" +
      "e\030\t \001(\t\022\017\n\007LastSeq\030\n \001(\003\022\016\n\006PColor\030\013 \001(\t" +
      "B,\n\033com.fss.fo.mserver.exchangeB\rPTMatch" +
      "Protos"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_com_fss_fo_mserver_exchange_PTMatch_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_com_fss_fo_mserver_exchange_PTMatch_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_com_fss_fo_mserver_exchange_PTMatch_descriptor,
              new java.lang.String[] { "Id", "Symbol", "ConfirmNo", "MatchVol", "Price", "MarketId", "IsActive", "Tradingdate", "Time", "LastSeq", "PColor", });
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }

  // @@protoc_insertion_point(outer_class_scope)
}
